C
      PROGRAM tran1x
C
      PARAMETER(MWV=150000,MMWV=12)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER INFILE*80,head_in(12)*10,head_in1*9
      CHARACTER commentFin*10
      CHARACTER OUTFILE*100
      dimension time(MWV)
      dimension XR(MWV,MMWV),X(MWV,MMWV),XR2(MWV,MMWV),X2(MWV,MMWV),
     *XR3(MWV,MMWV),X3(MWV,MMWV)
      COMPLEX*16 FX(MWV),FX_amp(MWV,MMWV)
      COMPLEX*16 FX2(MWV),FX2_amp(MWV,MMWV)
      COMPLEX*16 FX3(MWV),FX3_amp(MWV,MMWV)
      real MEANxr(MMWV),ISUMxr(MMWV),fin_com,fin_com2
C
C  Prompt for input RECON'ed file
C
      WRITE(*,1010) 
 1010 FORMAT(1X,/' ̓t@C͂Ă')
      READ(*,1020) INFILE
 1020 FORMAT(A80)
C *** Read input data file  ***
C
      OPEN(11,FILE=INFILE)
      write(*,*)
      write(*,*)' t@Cǂݍݒ'
        read(11,*)head_in1,(head_in(j),j=1,12)
        read(11,*)
        i=1
   10   read(11,*,end=11)time(i),(xr(i,j),j=1,12)
        i=i+1
        goto 10
   11 CLOSE(11)
c
      NT=i-1
      dt=time(2)-time(1)
      write(*,*)
      write(*,*)'NT and DT=',NT,DT
c
C *** change of + or -  ***
c
C      WRITE(*,*)
C      WRITE(*,*)' Change +/-? (YES=1)?? :'
C      READ(*,*)MYES
c
C      IF(MYES.EQ.1)THEN
C
C        WRITE(*,*)
C        WRITE(*,*)' Change from + to - of FILE 1 ? (YES=1)?? :'
C        READ(*,*)MY1
c
C         IF(MY1.EQ.1)THEN
C           DO 100 I=1,NT
C		   do 101 j=1,40
C             XR(I,j)=-XR(I,j)
C  101      CONTINUE
C  100      CONTINUE
C      END IF
c
C        WRITE(*,*)' Change from + to - of FILE 2 ? (YES=1)?? :'
C        READ(*,*)MY2
c
C         IF(MY2.EQ.1)THEN
C           DO 110 I=1,NT
C             XR2(I)=-XR2(I)
C  110      CONTINUE
C         END IF
c
C        WRITE(*,*)' Change from + to - of FILE 3 ? (YES=1)?? :'
C        READ(*,*)MY3
C
C         IF(MY3.EQ.1)THEN
C           DO 120 I=1,NT
C             XR3(I)=-XR3(I)
C  120      CONTINUE
C         END IF
C
C      END IF
c
       Do 211 j=1,12
	 ISUMxr(j) = 0
        DO 201 i=1,nt
		ISUMxr(j) = ISUMxr(j) + xr(i,j)
  201	  CONTINUE
c
       MEANxr(j) =real(ISUMxr(j)) / real(nt)
  211  CONTINUE
C
C       ISUMxr2 = 0
C
C       DO 201,i=1,nt
C
C       ISUMxr2 = ISUMxr2 + xr2(i)
C
C  201  CONTINUE
C
C       MEANxr2 = real(ISUMxr2)/real(nt)
C
C       ISUMxr3 = 0
C
C       DO 301,i=1,nt
C
C       ISUMxr3 = ISUMxr3 + xr3(i)
C
C  301  CONTINUE
C
C       MEANxr3 = real(ISUMxr3) /real( nt)
C      
      write(*,*)
      write(*,*)'␳܂'
	  Do 56 j=1,12
           DO 55 I=2,NT
             XR(I,j)=XR(I,j)- MEANxr(j)
  55      CONTINUE
  56    CONTINUE
c
C
C *** FOURIER TRANSFORM ***
C
      NF=2
      DO 200 I=2,17
        NF=2*NF
        IF(NF.GE.NT)GOTO 30
  200 CONTINUE
      WRITE(*,*)' NT>2**17 !!!!!'
      STOP
   30 IF1=I
      WRITE(*,*)
      WRITE(*,*)' IF1,NF=',IF1,NF
C*****************************************
C
      DUR=dFLOAT(NF)*DT
      DOM=6.2831853070d0/DUR
      NOM=NF/2+1
      EOM=DOM*NOM
C      WRITE(*,*)
C      WRITE(*,*)' DUR,DOM,NOM,EOM=',DUR,DOM,NOM,EOM
C      WRITE(*,*)' Highest Frequency (hz)=',EOM/6.2831853070d0
C*****************************************
C *** BAND PATH ***
C
C     WRITE(*,*)
C     WRITE(*,*)'tB^[(0.1,0.2,999,9999)܂?i͂FPj'
C     READ(*,*)NBD
C
C      IF(NBD.EQ.1)THEN
C
        WRITE(*,*)
        WRITE(*,*)' TRAPEZOIDAL BAND PATH FILTER'
C       WRITE(*,*)' ENTER fL1<fL2<fH1<fH2 (Hz)'
        WRITE(*,*)' fL1=0.1 fL2=0.2 fH1=999 fH2=9999(Hz)'
        WRITE(*,*)
        WRITE(*,*)' ampt@Co͂Ă܂'
        OML1=0.1*6.2831853070d0
        OML2=0.2*6.2831853070d0
        OMH1=999*6.2831853070d0
        OMH2=9999*6.2831853070d0
c      END IF
C*****************************************
c      WRITE(*,*)
c      WRITE(*,*)' Integration/Differentiation:'
c      WRITE(*,*)' NO Change         :                 (Enter=0)'
c      WRITE(*,*)' Integration       : Ex.) acc -> vel (Enter=1)'
c      WRITE(*,*)' Double Integration: Ex.) acc -> dis (Enter=2)'
c      WRITE(*,*)' Differentiation:  : Ex.) Vel -> acc (Enter=3)'
c      READ(*,*)NIT
C*****************************************
	DO 305 j=1,12
C
      DO 300 I=1,NT
        FX(I)=dCMPLX(XR(I,j),0.d0)
        FX2(I)=dCMPLX(XR(I,j),0.d0)
        FX3(I)=dCMPLX(XR(I,j),0.d0)
  300 CONTINUE
      DO 310 I=NT+1,NF
        FX(I)=(0.d0,0.d0)
        FX2(I)=(0.d0,0.d0)
        FX3(I)=(0.d0,0.d0)
  310 CONTINUE
C
      CALL WVFAST(NF,FX,MWV,-1)
      CALL WVFAST(NF,FX2,MWV,-1)
      CALL WVFAST(NF,FX3,MWV,-1)
C      DUR=dFLOAT(NF)*DT
      DO 400 I=1,NF
        FX(I)=FX(I)*DT
        FX2(I)=FX2(I)*DT
        FX3(I)=FX3(I)*DT
  400 CONTINUE
C
c      FOM=0.d0
C     
C      IF(NBD.EQ.1)THEN
        DO 500 I = 1,NOM
           OMEGA=dFLOAT(I-1)*DOM
           IF(OMEGA.LE.OML1)then
C            FX(I)=(0.d0,0.d0)
             FX2(I)=(0.d0,0.d0)
             FX3(I)=(0.d0,0.d0)
           end if
           IF(OMEGA.GE.OMH2)then
C            FX(I)=(0.d0,0.d0)
             FX2(I)=(0.d0,0.d0)
             FX3(I)=(0.d0,0.d0)
           end if
           AA=1.d0
           IF(OMEGA.LT.OML2)AA=(OMEGA-OML1)/(OML2-OML1)
           IF(OMEGA.GT.OMH1)AA=(OMH2-OMEGA)/(OMH2-OMH1)
C	   FX(I) = AA*FX(I)
	   FX2(I) = AA*FX2(I)
	   FX3(I) = AA*FX3(I)
  500   CONTINUE
C      END IF
C
c
C      IF(NIT.EQ.0)THEN
        DO 550 I = 2,NOM
           OMEGA=dFLOAT(I-1)*DOM
	   FX2(I) = FX2(I)/dcmplx(0.d0,omega)
	   FX3(I) = FX3(I)/(-omega*omega)
  550   CONTINUE
C      END IF
c
C      IF(NIT.EQ.2)THEN
C        DO 560 I = 2,NOM
C           OMEGA=dFLOAT(I-1)*DOM
C	   FX(I) = FX(I)/(-omega*omega)
C  560   CONTINUE
C      END IF
c
C      IF(NIT.EQ.3)THEN
C        DO 570 I = 2,NOM
C           OMEGA=dFLOAT(I-1)*DOM
C	   FX(I) = FX(I)*dcmplx(0.d0,omega)
C  570   CONTINUE
C      END IF
C
c * Output Fourier Spectrum data *
c
C      write(*,*)
C      write(*,*)'Fourier Spectrum data are stored in "amp3.csv"'
C      open(10,file='amp3.csv',status='unknown')
C      write(10,*)'frequency(Hz),',head2,',',head3,',',head4
      DO 680 I = 2,NOM
C        f=dFLOAT(I-1)*DOM/6.2831853070d0
        FX_amp(I,j)=FX(I)
        FX2_amp(I,j)=FX2(I)
        FX3_amp(I,j)=FX3(I)
  680 CONTINUE
C 1900 format(f15.8,6(',',e15.8))
C      close(10)
C
C *** INVERSE FOURIER TRANSFORM  ***
C
      DO 600 I=2,NF/2
           FX(NF+2-I)=dCMPLX(dREAL(FX(I)),-dIMAG(FX(I)))
           FX2(NF+2-I)=dCMPLX(dREAL(FX2(I)),-dIMAG(FX2(I)))
           FX3(NF+2-I)=dCMPLX(dREAL(FX3(I)),-dIMAG(FX3(I)))
  600 CONTINUE
C
      CALL WVFAST(NF,FX,MWV,1)
      CALL WVFAST(NF,FX2,MWV,1)
      CALL WVFAST(NF,FX3,MWV,1)
C
C *** WAVE DATA ***
C
      DO 700 I = 1,NF
         XR(I,j)=dREAL(FX(I))/DUR
         XR2(I,j)=dREAL(FX2(I))/DUR
         XR3(I,j)=dREAL(FX3(I))/DUR
  700 CONTINUE
  305 CONTINUE

      WRITE(*,*)
      WRITE(*,*)' ampt@Co͂܂'
      WRITE(*,*)
      WRITE(*,*)'  nkgt@Co͂Ă܂'
      i = index(INFILE,'.')
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_acc_amp.csv'
      open(10,file=OUTFILE,status='unknown')
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_vel_amp.csv'
      open(11,file=OUTFILE,status='unknown')
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_dis_amp.csv'
      open(12,file=OUTFILE,status='unknown')
      write(10,1901)'frequency(Hz)',(head_in(j),j=1,12)
      write(11,1901)'frequency(Hz)',(head_in(j),j=1,12)
      write(12,1901)'frequency(Hz)',(head_in(j),j=1,12)
 1901 format(a13,12(',',a10))
      DO 681 I = 2,NOM
        f=dFLOAT(I-1)*DOM/6.2831853070d0
        write(10,1900)f,(cdabs(FX_amp(I,j)),j=1,12)
        write(11,1900)f,(cdabs(FX2_amp(I,j)),j=1,12)
        write(12,1900)f,(cdabs(FX3_amp(I,j)),j=1,12)
  681 CONTINUE
 1900 format(f15.8,12(',',e15.8))
      close(12)
      close(11)
      close(10)
c *** Cut ***
c
      do 304 i=1,nt
	 do 306 j=1,12

        x(i,j)=xr(i,j)
        x2(i,j)=xr2(i,j)
        x3(i,j)=xr3(i,j)
  306 end do
  304 end do

C      write(*,*)
C      write(*,*)'Cutting data? (No=0,Yes=1)'
C      read(*,*)icut
C      if(icut.eq.1)then
C        write(*,*)'Enter Starting Time (sec)'
C        read(*,*)stime
C        nstime=int(stime/dt)
C        write(*,*)'Number of Cutting Data =',nstime
C        write(*,*)'Enter Duration (sec)'
C        read(*,*)dur
C        ndur=int(dur/dt)+1
C        write(*,*)'Number of data =',ndur
C	 do 307 j=1,40
C        do i=1,ndur
C          if((i+nstime).le.0)then
C            x(i,j)=0.d0
C            x2(i)=0.d0
C            x3(i)=0.d0
C	  else
C            x(i,j)=xr(i+nstime,j)
C            x2(i)=xr2(i+nstime)
C            x3(i)=xr3(i+nstime)
C          end if
C        end do
C  307	 Continue
C	nt=ndur
C        write(*,*)'New nt =',nt
C      end if
C
c *** output ***
c
C      write(*,*)
C      write(*,*)'f[^XLbv܂'
C      read(*,*)iskip
      iskip=0
      iskip=iskip+1
      WRITE(*,2010)
 2010 FORMAT(/1X,'  nkgt@Co͂܂')
      WRITE(*,*)
      WRITE(*,*)'   t@C̍ŏItH[}bgĂ܂'
C     READ(*,2020) INFILE
 2020 FORMAT(A30)
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_acc.csv'
      OPEN(13,FILE=OUTFILE,STATUS='unknown')
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_vel.csv'
      OPEN(14,FILE=OUTFILE,STATUS='unknown')
      OUTFILE = INFILE(1:4)//'_'//INFILE(5:8)//'_'//INFILE(9:12)//'_'
     *//INFILE(13:14)// '_dis.csv'
      OPEN(15,FILE=OUTFILE,STATUS='unknown')
      write(13,2001)head_in1,(head_in(j),j=1,12)
      write(14,2001)head_in1,(head_in(j),j=1,12)
      write(15,2001)head_in1,(head_in(j),j=1,12)
 2001 format(a7,12(',',a10))
      do i=1,nt,iskip
      write(13,2000)dt*(i-1),(X(I,j),j=1,12)
      write(14,2000)dt*(i-1),(X2(I,j),j=1,12)
      write(15,2000)dt*(i-1),(X3(I,j),j=1,12)
C      write(11,2000)dt*(i-1),X1(I)-X1(1),x2(i)-X2(1),x3(i)-x3(1)
      end do
 2000 format(f10.5,12(',',e15.8))
      CLOSE(15)
      CLOSE(14)
      CLOSE(13)
	 fin_com=rand()*1000000/3
C	 fin_com= mod(int(fin_com2),3)
	 commentFin="Done"
	if(fin_com.GE.0.and.fin_com.LT.3)then
	  commentFin=""
      end if
	if (fin_com.GE.3. And .fin_com.LT.6)then
	  commentFin=""
      end if
	if (fin_com.GE.6. and .fin_com.LT.9) then
	  commentFin="傤"
      end if
	if (fin_com.GE.9) then
	  commentFin=""
      end if

      write(*,*)commentFin,fin_com
C      read(*,*)
c
        STOP
	END
C
C *** FOURIER TRANSFORM OR INVERSE FOURIER TRANSFORM
C
      SUBROUTINE WVFAST(N,A,MOM,IND)
C
C *** N   : NUMBER OF FOURIER COEFF. OR WAVE ( = 2**I )
C *** A(I): FOURIER COEFFICIENTS ( N/2+1 ) OR WAVE ( REAL PART )
C    ( FOURIER SPECTRUM = FOURIER COEFFICIENTS * DURATION/2.0 )
C *** MOM : N IN MAIN DIMMENSION
C         : IF MWV > 2**13(=8192), CAN NOT USE !!!
C *** IND : = -1 : TRANS.,   = 1 : INVERSE TRANS.
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 A(MOM),TEMP,THETA
C
C *** CALUCURATION OF FFT
C
      PAI=3.1415926540d0
      J=1
      DO 140 I=1,N
        IF(I.GE.J) GO TO 110
        TEMP=A(J)
        A(J)=A(I)
        A(I)=TEMP
  110   M=N/2
  120   IF(J.LE.M) GO TO 130
        J=J-M
        M=M/2
        IF(M.GE.2) GO TO 120
  130   J=J+M
  140 CONTINUE
      KMAX=1
  150 IF(KMAX.GE.N) RETURN
      ISTEP=KMAX*2
      DO 170 K=1,KMAX
        THETA=dCMPLX(0.d0,PAI*dFLOAT(IND*(K-1))/dFLOAT(KMAX))
        DO 160 I=K,N,ISTEP
          J=I+KMAX
          TEMP=A(J)*CdEXP(THETA)
          A(J)=A(I)-TEMP
          A(I)=A(I)+TEMP
  160   CONTINUE
  170 CONTINUE
      KMAX=ISTEP
      GO TO 150
C
      END
